

; Edit these as appropriate for your descriptors
#define NUM_CONFIGURATIONS  1

; Define the states that the USB interface can be in
#define	POWERED#STATE		0
#define	DEFAULT#STATE		1
#define	BUF#ADDRESS#STATE	2
#define	CONFIG#STATE		3

; Define the states for Control EndPoints
#define	EP_IDLE_STATE		0
#define	EP_SETUP_STATE		1
#define	EP_DISABLED_STATE	0xFF

#define	ENDPT_DISABLED		0
#define ENDPT_IN_ONLY		2
#define ENDPT_OUT_ONLY		4
#define ENDPT_CONTROL		6	; enable for in, out and setup
#define ENDPT_NON_CONTROL 	0x0E	; enable for in, and out


#define INT_STAT_MASK_RESET			1
#define INT_STAT_MASK_ERROR			2
#define INT_STAT_MASK_TOKEN_DONE	4
#define INT_STAT_MASK_SLEEP			8
#define INT_STAT_MASK_STALL			0x10

#define TOKEN_OUT			1 << 2
#define TOKEN_ACK       	2 << 2
#define TOKEN_IN			9 << 2
#define TOKEN_SETUP			0x0D << 2

#define USB_Buffer    		0xB8	; on page 3 so actual address 0x1B8

; offsets from the beginning of the Buffer Descriptor
#define BYTE#COUNT			1
#define	BUF#ADDRESS			2

; Descriptor types
;#define  DEVICE         	1
#define  CONFIGURATION  	2
#define  STRING         	3
#define  INTERFACE      	4
#define  ENDPOINT       	5

; offsets from the beginning of the setup data record
#define  bmRequestType  	0
#define  bRequest			1
#define  wValue				2
#define  wValueHigh			3
#define  wIndex				4
#define  wIndexHigh			5
#define	 wLength			6
#define  wLengthHigh		7

#define  CLEAR_FEATURE		1
#define  GET_CONFIGURATION	8
#define  GET#DESCRIPTOR		6
#define  GET#STRING_DESCRIPTOR	0x66
#define  GET_INTERFACE		0x0A
#define  GET_STATUS			0
#define	 SET#BUF#ADDRESS	5
#define  SET_CONFIGURATION	9
#define  SET_FEATURE		3
#define  SET_INTERFACE		0x0B
#define  HID_SET_REPORT		0x21
#define  VEND_SET_MEMORY	0x80

#define SVCUSBINT			1 << 2
#define SVCTOKENDONE		2 << 2
#define SVCRESET			3 << 2
#define SVCSLEEP			4 << 2
#define SVCSTALL			5 << 2
#define SVCERROR			6 << 2
#define SVCACTIVITY			7 << 2
#define TOKENOUT			8 << 2
#define TOKENIN				9 << 2
#define TOKENSETUP			0x0A << 2
#define CLEARFEATURE		0x0B << 2
#define GETCONFIG			0x0C << 2
#define GETDESCRIPTOR		0x0D << 2
#define GETINTERFACE		0x0E << 2
#define GETSTATUS			0x0F << 2
#define SETADDRESS			0x10 << 2
#define SETCONFIG			0x11 << 2
#define SETFEATURE			0x12 << 2
#define SETINTERFACE		0x13 << 2
#define FINISHSETADDRESS	0x14 << 2
#define COPYDESC2EP0		0x15 << 2
#define COPYSTRINGDESC2EP0	0x16 << 2
#define ZEROLENPACKET		0x17 << 2

REQUEST@ERROR	macro
	bsf	STATUS,RP0				; page 3
	movf	USTAT,w				; get the status register
	addlw	0xA0				; add the offset to the beginning of the BD's
	movwf	FSR
	bsf	INDF,PP_EP_STALL		; set endpoint stall bit
	bcf	STATUS,RP0				; back to page 2
	endm	

; *********************************************************************
; wait here until the enumeration process is complete.
; This is implemented as a macro to avoid chewing up another stack level
; *********************************************************************
Configured@USB macro
	banksel	USWSTAT
	clrwdt						; clear the watch dog timer.
	movlw	3
	andwf	USWSTAT,w			; save lower 2 bits of USWSTAT
	xorlw	CONFIG#STATE		; compare with configured state
	btfss	STATUS,Z			; are we configured?
	goto	$ - 5				; nope, keep waiting ...
	endm



