;
; Buffer Descriptor Byte Aliases
;
#define    __STAT            0            ; Endpoint Buffer Descriptor Status Register offset
#define    __CNT             1            ; Endpoint Buffer Count offset
#define    __ADRL            2            ; Endpoint Buffer Address offset Low
#define    __ADRH            3            ; Endpoint Buffer Address offset High

; __STAT Bit Aliases
#define    __BC8             0            ; Upper Count Bit
#define    __BC9             1            ; Upper Count Bit
#define    __BSTALL          2            ; Buffer Stall Enable
#define    __DTSEN           3            ; Data Toggle Synch Enable
#define    __INCDIS          4            ; Address Increment Disable
#define    __KEN             5            ; BD Keep Enable
#define    __DTS             6            ; Data Toggle Synch Value
#define    __UOWN            7            ; USB Ownership
#define    __PID             2            ; Packet Identifier (4 bits)

; __USB_STAT bit aliases
#define    __RemoteWakeup    0            ; [0]Disabled [1]Enabled
#define    __CTRL_TRF_MEM    1            ; [0]RAM      [1]ROM
#define    __cdc_mem_type    2            ; [0]RAM      [1]ROM

; __SetupPkt Byte and Bit Aliases
#define    __bmRequestType   0
#define    __bRequest        1
#define    __wValue          2
#define    __wIndex          4
#define    __wLength         6

#define    __Recipient       0        ; Device,Interface,Endpoint,Other (5 bits)
#define    __RequestType     5        ; Standard, Class, Vendor, Reserved (2 bits)
#define    __DataDir         7        ; Host-to-device, Device-to-host
#define    __bFeature        2        ; DEVICE_REMOTE_WAKEUP, ENDPOINT_HALT

#define    __bReportID       2        ; In a SET_REPORT or GET_REPORT request
#define    __bReportType     3        ; In a SET_REPORT or GET_REPORT request

#define    __bDscIndex       2        ; For Configuration and String DSC Only
#define    __bDscType        3        ; Device Configuration String
#define    __wLangID         4        ; Language ID

#define    __bDevADR         2        ; Device Address 0 - 127
#define    __bDevADRH        3        ; Must equal zero

#define    __bCfgValue       2        ; Configuration Value 0 - 255
#define    __bCfgRSD         3        ; Must equal zero (Reserved)

#define    __bAltID          2        ; Alternate Setting Value 0 - 255
#define    __bAltID_H        3        ; Must equal zero (Reserved)
#define    __bIntfID         4        ; Interface Number Value 0 - 255
#define    __bIntfID_H       5        ; Must equal zero

#define    __bEPID           4        ; Endpoint ID (Number & Direction)
#define    __bEPID_H         5        ; Must equal zero

#define    __EPNum           0        ; Endpoint Number 0 - 15 (4 bits)
#define    __EPDir           7        ; Endpoint Direction: 0 - OUT, 1 - IN

NOLIST
; CDC line_coding Byte and Bit Aliases
ifdef __USB_USE_CDC
LIST
#define    __dwDTERate      0         ; Complex data structure
#define    __bCharFormat    4
#define    __bParityType    5
#define    __bDataBits      6
; control_signal_bitmap Byte and Bit Aliases
#define    __DTE_PRESENT     0        ; [0] Not Present  [1] Present
#define    __CARRIER_CONTROL 1        ; [0] Deactivate   [1] Activate
NOLIST
endif
LIST
